#include <stdlib.h>



#define total 10
#define colon 301
#define ligne 401

struct ghost {
	int une;
	int col;
	int row;
	struct ghost * back;
	struct ghost * next;

	struct ghost * down,*up,*left,*right, *dleft, *dright, *uleft, *uright;
} ;

//==========================================================================
//==========================================================================
//============================= ghost ======================================
//==========================================================================
//==========================================================================

struct ghost * head;
struct ghost * tail;
struct ghost * ici;

/*
void loop(void)
{
			ici = head;
			while (ici->next != NULL)
			{
				...

				ici = ici->next;
			}
}
*/


void creer (void)
{
	if (tail == 0)
	{
		head = (struct ghost *) malloc(sizeof(struct ghost));
		head->back = NULL;
		head->next = NULL;
		tail = head;
	}
	tail->next = (struct ghost *) malloc(sizeof(struct ghost));
	tail->next->back = tail;
	tail->next->next = NULL;
	tail = tail->next;
	return;
}

void detruire (struct ghost * mort)
{
	if ((mort->back == head)||(mort->next == head))
	{
		return;
	}
	if ((mort == tail)||(mort == head))
	{
		if (mort == tail)
		{
			tail = mort->back;
			mort->back->next = NULL;
			free(mort);
		}
		if (mort == head)
		{
			head = mort->next;
			mort->next->back = NULL;
			free(mort);
		}
	} else {
		mort->back->next = mort->next;
		mort->next->back = mort->back;
		free(mort);
	}
}
//==========================================================================
//==========================================================================
//============================ matrix ======================================
//==========================================================================
//==========================================================================
struct ghost * matrix[colon][ligne];

void join_the_matrix(struct ghost * aspirant)
{
		if (matrix[aspirant->col][aspirant->row] == NULL)
		{	matrix[aspirant->col][aspirant->row] = aspirant;	
		} else {
			detruire(aspirant);
		}
}

void touch_the_matrix(struct ghost * toucher)
{
	if (toucher->row > 1)
	{	toucher->down = matrix[toucher->col][toucher->row-1];
	} else {	toucher->down = toucher;	}
	if (toucher->row < 399)
	{	toucher->up = matrix[toucher->col][toucher->row+1];
	} else {	toucher->up = toucher;	}
	if (toucher->col > 1)
	{	toucher->left = matrix[toucher->col-1][toucher->row];
	} else {	toucher->left = toucher;	}
	if (toucher->col < 299)
	{	toucher->right = matrix[toucher->col+1][toucher->row];
	} else {	toucher->right = toucher;	}
	if ((toucher->row > 1)&&(toucher->col > 1))
	{	toucher->dleft = matrix[toucher->col-1][toucher->row-1];
	} else {	toucher->dleft = toucher;	}
	if ((toucher->row < 399)&&(toucher->col > 1))
	{	toucher->uleft = matrix[toucher->col-1][toucher->row+1];
	} else {	toucher->uleft = toucher;	}
	if ((toucher->row > 1)&&(toucher->col < 299))
	{	toucher->dright = matrix[toucher->col+1][toucher->row-1];
	} else {	toucher->dright = toucher;	}
	if ((toucher->row < 399)&&(toucher->col < 299))
	{	toucher->uright = matrix[toucher->col+1][toucher->row+1];
	} else {	toucher->uright = toucher;	}
}

void go_down(struct ghost * mover)
{
	if (mover->down == NULL)
	{
		matrix[mover->col][mover->row] = NULL;
		matrix[mover->col][mover->row-1] = mover;
		mover->row -= 1;
	} else {
		matrix[mover->col][mover->row] = mover->down;
		matrix[mover->col][mover->row-1] = mover;
		mover->row -= 1;
		mover->down->row +=1;
	}
}

void go_up(struct ghost * mover)
{
	if (mover->up == NULL)
	{
	} else {
		matrix[mover->col][mover->row] = mover->up;
		matrix[mover->col][mover->row+1] = mover;
		mover->row += 1;
		mover->up->row -=1;
	}
}

void go_left(struct ghost * mover)
{
	if (mover->left == NULL)
	{
		matrix[mover->col][mover->row] = NULL;
		matrix[mover->col-1][mover->row] = mover;
		mover->col -= 1;
	} else {
	}
}

void go_right(struct ghost * mover)
{
	if (mover->right == NULL)
	{
		matrix[mover->col][mover->row] = NULL;
		matrix[mover->col+1][mover->row] = mover;
		mover->col += 1;
	} else {
	}
}

void go_dleft(struct ghost * mover)
{
	if (mover->dleft == NULL)
	{
		matrix[mover->col][mover->row] = NULL;
		matrix[mover->col-1][mover->row-1] = mover;
		mover->row -= 1;
		mover->col -= 1;
	} else {
	}
}

void go_dright(struct ghost * mover)
{
	if (mover->dright == NULL)
	{
		matrix[mover->col][mover->row] = NULL;
		matrix[mover->col+1][mover->row-1] = mover;
		mover->row -= 1;
		mover->col += 1;
	} else {
	}
}

//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//===========================  feng  =======================================
//===========================  shui  =======================================
//=========================== system =======================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================

void element(struct ghost * point)
{
//=======================================================================================
//===============================get 8 direction if there available======================
//=======================================================================================

	touch_the_matrix(point);

//=========================================================================
//===================== what do we have here ? ============================
//=========================================================================
	switch (point->une)
	{
	//-------------------> earth
		//	the simple element
		case 1:
			if (point->down != point)
			{if (point->down == NULL)
			{	/*if (point->row > 2)
                    		{if (matrix[point->col][point->row-2] == NULL)
				{	if (point->row > 3)
                            		{if (matrix[point->col][point->row-3] == NULL)
					{	matrix[point->col][point->row] = NULL;
						matrix[point->col][point->row-3] = point;
						point->row -= 3;
						break;
					}}
					matrix[point->col][point->row] = NULL;
					matrix[point->col][point->row-2] = point;
					point->row -= 2;
					break;
				}}*/
				//matrix[point->col][point->row] = NULL;
				//matrix[point->col][point->row-1] = point;
				//point->row -= 1;
				go_down(point);
				break;
			} else {
            			if (point->down->une == 2)
				{	//matrix[point->col][point->row] = point->down;
					//matrix[point->col][point->row-1] = point;
					//point->row -= 1;
					//point->down->row +=1;
					go_down(point);
					break;
				}
			}}

            		if (point->dleft != point)
			{if (point->dleft == NULL)
			{	//matrix[point->col][point->row] = NULL;
				//matrix[point->col-1][point->row-1] = point;
				//point->row -= 1;
				//point->col -= 1;
				go_dleft(point);
				break;
			}}

            		if (point->dright != point)
			{if (point->dright == NULL)
			{	//matrix[point->col][point->row] = NULL;
				//matrix[point->col+1][point->row-1] = point;
				//point->row -= 1;
				//point->col += 1;
				go_dright(point);
				break;
			}}
			break;
	//-------------------> water
		//	the tempered element
		case 2:
			if (point->down != point)
			{if (point->down == NULL)
			{
				/*if (point->row > 2)
                                {if (matrix[point->col][point->row-2] == NULL)
				{	matrix[point->col][point->row] = NULL;
					matrix[point->col][point->row-2] = point;
					point->row -= 2;
					break;
				}}*/
						            
				//matrix[point->col][point->row] = NULL;
				//matrix[point->col][point->row-1] = point;
				//point->row -= 1;
				go_down(point);
				break;
			}}
                   
			if (point->left != point)
			{if (point->left == NULL)
			{	//matrix[point->col][point->row] = NULL;
				//matrix[point->col-1][point->row] = point;
				//point->col -= 1;
				go_left(point);
				break;
			}}
					
			if (point->right != point)
			{if (point->right == NULL)
			{	//matrix[point->col][point->row] = NULL;
				//matrix[point->col+1][point->row] = point;
				//point->col += 1;
				go_right(point);
				break;
			}}
					
			break;
	//-------------------> wood
		//	the variable element
		case 3:
			if (point->up != point)
			{if (point->up != NULL)
			{if (point->up->une == 1)
			{	//matrix[point->col][point->row] = point->up;
				//matrix[point->col][point->row+1] = point;
				//point->row += 1;
				//point->up->row -=1;
				go_up(point);
				break;
			}}}

			if (point->down != point)
			{if (point->down == NULL)
			{	//matrix[point->col][point->row] = NULL;
				//matrix[point->col][point->row-1] = point;
				//point->row -= 1;
				go_down(point);
				break;
			} else {
				if (point->down->une == 2)	
				{
					if (point->dleft != point)
					{if (point->dleft != NULL)
					{if (point->dleft->une == 3)
					{	break;
					}}}

					if (point->dright != point)
					{if (point->dright != NULL)
					{if (point->dright->une == 3)
					{	break;
					}}}
				//matrix[point->col][point->row] = point->down;
				//matrix[point->col][point->row-1] = point;
				//point->row -= 1;
				//point->down->row +=1;
				go_down(point);
				break;
				}
			}}

			if ((point->left != point)&&(point->right != point))
			{

			if (point->left != NULL)
			{if (point->left->une == 2)
			{if (point->right == NULL)
			{	//matrix[point->col][point->row] = point->left;
				//matrix[point->col-1][point->row] = point;
				//point->col -= 1;
				//point->left->col +=1;
				go_right(point);
				break;
			}}}

			if (point->right != NULL)
			{if (point->right->une == 2)
			{if (point->left == NULL)
			{	//matrix[point->col][point->row] = point->right;
				//matrix[point->col+1][point->row] = point;
				//point->col += 1;
				//point->right->col -=1;
				go_left(point);
				break;
			}}}

			}
			break;
	//-------------------> metal
		//	the stable element , when together , they simply dont move
		//	alone they fall directly till they find stable element	
		case 4:
			if (point->down != point)
			{if (point->down == NULL)
			{

				if (point->up != point)
				{if (point->up != NULL)
				{if (point->up->une == 4)
				{	break;
				}}}
				if (point->uleft != point)
				{if (point->uleft != NULL)
				{if (point->uleft->une == 4)
				{	break;
				}}}
				if (point->uright != point)
				{if (point->uright != NULL)
				{if (point->uright->une == 4)
				{	break;
				}}}
				if (point->left != point)
				{if (point->left != NULL)
				{if (point->left->une == 4)
				{	break;
				}}}
				if (point->right != point)
				{if (point->right != NULL)
				{if (point->right->une == 4)
				{	break;
				}}}
				if (point->dleft != point)
				{if (point->dleft != NULL)
				{if (point->dleft->une == 4)
				{	break;
				}}}
				if (point->dright != point)
				{if (point->dright != NULL)
				{if (point->dright->une == 4)
				{	break;
				}}}


				//matrix[point->col][point->row] = NULL;
				//matrix[point->col][point->row-1] = point;
				//point->row -= 1;
				go_down(point);
				break;
			}}
			break;
	//------------------> fire
		//	the transformation element
		case 5:
			break;
	//----------------------------end
	}
//=========================================================================
//===================== why do i have problem ? ============================
//=========================================================================

}

//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
